<?php

/*----------------------------------------------------------------------------------|  simontech.me  |----/


				Award Manager - Public Edition 


/-------------------------------------------------------------------------------------------------------/





	@version		1.0.7


	@build			8th June, 2019


	@created		19th April, 2019


	@package		Award Manager


	@subpackage		ajax.json.php


	@author			SimonTech <https://simontech.me>	


	@copyright		Copyright (C) 2019 SimonTech Development. All Rights Reserved


	@license		GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html


  ____  _____  _____  __  __  __      __       ___  _____  __  __  ____  _____  _  _  ____  _  _  ____ 


 (_  _)(  _  )(  _  )(  \/  )(  )    /__\     / __)(  _  )(  \/  )(  _ \(  _  )( \( )( ___)( \( )(_  _)


.-_)(   )(_)(  )(_)(  )    (  )(__  /(__)\   ( (__  )(_)(  )    (  )___/ )(_)(  )  (  )__)  )  (   )(  


\____) (_____)(_____)(_/\/\_)(____)(__)(__)   \___)(_____)(_/\/\_)(__)  (_____)(_)\_)(____)(_)\_) (__) 





/------------------------------------------------------------------------------------------------------*/





// No direct access to this file


defined('_JEXEC') or die('Restricted access');





/**


 * Award_manager Ajax Controller


 */


class Award_managerControllerAjax extends JControllerLegacy


{


	public function __construct($config)


	{


		parent::__construct($config);


		// make sure all json stuff are set


		JFactory::getDocument()->setMimeEncoding( 'application/json' );


		JResponse::setHeader('Content-Disposition','attachment;filename="getajax.json"');


		JResponse::setHeader("Access-Control-Allow-Origin", "*");


		// load the tasks 

		$this->registerTask('uploadfile', 'ajax');

		$this->registerTask('removeFile', 'ajax');


	}





	public function ajax()


	{


		$user 		= JFactory::getUser();


		$jinput 	= JFactory::getApplication()->input;


		// Check Token!


		$token 		= JSession::getFormToken();


		$call_token	= $jinput->get('token', 0, 'ALNUM');


		if($token == $call_token)


		{


			$task = $this->getTask();


			switch($task)


			{

				case 'uploadfile':

					try

					{

						$returnRaw = $jinput->get('raw', false, 'BOOLEAN');

						$targetValue = $jinput->get('target', NULL, 'WORD');

						$typeValue = $jinput->get('type', NULL, 'WORD');

						if($targetValue && $typeValue && $user->id != 0)

						{

							$result = $this->getModel('ajax')->uploadfile($targetValue, $typeValue);

						}

						else

						{

							$result = false;

						}

						if($callback = $jinput->get('callback', null, 'CMD'))

						{

							echo $callback . "(".json_encode($result).");";

						}

						elseif($returnRaw)

						{

							echo json_encode($result);

						}

						else

						{

							echo "(".json_encode($result).");";

						}

					}

					catch(Exception $e)

					{

						if($callback = $jinput->get('callback', null, 'CMD'))

						{

							echo $callback."(".json_encode($e).");";

						}

						else

						{

							echo "(".json_encode($e).");";

						}

					}

				break;

				case 'removeFile':

					try

					{

						$returnRaw = $jinput->get('raw', false, 'BOOLEAN');

						$filenameValue = $jinput->get('filename', NULL, 'CMD');

						$targetValue = $jinput->get('target', NULL, 'WORD');

						$flushValue = $jinput->get('flush', NULL, 'INT');

						$typeValue = $jinput->get('type', NULL, 'WORD');

						if($filenameValue && $targetValue && $flushValue && $typeValue && $user->id != 0)

						{

							$result = $this->getModel('ajax')->removeFile($filenameValue, $targetValue, $flushValue, $typeValue);

						}

						else

						{

							$result = false;

						}

						if($callback = $jinput->get('callback', null, 'CMD'))

						{

							echo $callback . "(".json_encode($result).");";

						}

						elseif($returnRaw)

						{

							echo json_encode($result);

						}

						else

						{

							echo "(".json_encode($result).");";

						}

					}

					catch(Exception $e)

					{

						if($callback = $jinput->get('callback', null, 'CMD'))

						{

							echo $callback."(".json_encode($e).");";

						}

						else

						{

							echo "(".json_encode($e).");";

						}

					}

				break;


			}


		}


		else


		{


			if($callback = $jinput->get('callback', null, 'CMD'))


			{


				echo $callback."(".json_encode(false).");";


			}


			else


  			{


				echo "(".json_encode(false).");";


			}


		}


	}


}


